/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jemu.core.device.tape;

/**
 *
 * @author Markus
 */

import jemu.system.cpc.*;
import javax.sound.sampled.*;

import java.io.*;
import java.util.zip.*;
import javax.swing.*;
import jemu.ui.Switches;

/**
 *
 *
 */
public class WAV2BYTE {


  private AudioFormat format;


  /**
   * Opens a sound from a file.
   */
  public WAV2BYTE(String filename) {
    try {
     CPC.tapesample = new byte[0];
    InputStream result;
   
      result = new FileInputStream(filename);
    if (filename.toLowerCase().endsWith(".zip") || filename.toLowerCase().endsWith(".jtp")) {
      ZipInputStream str = new ZipInputStream(result);
      str.getNextEntry();
      result = str;
    }
      AudioInputStream stream = AudioSystem.getAudioInputStream(result);

      format = stream.getFormat();
    System.out.println("Format: " + format);
System.out.println("Bytes: "+ stream.getFrameLength());

if (stream.getFrameLength() > (int)Switches.availmem){
    String message="";
    System.out.println("Cannot open file.");
    if (format.getSampleRate() >= 24000.0){
    System.out.println("Try to reduce this file to 22050 Hz.");
    message="Try to reduce this file to 22050 Hz.";
    } else
    if (format.getSampleRate() >= 11030.0){
    System.out.println("Try to reduce this file to 11025 Hz.");
    message="Try to reduce this file to 11025 Hz.";
    }
    JOptionPane.showMessageDialog(null, "Cannot open file.\nFile is too large.\n" + message);
    return;
}
// check the audio format and set CPC tape delay

    CPC.tape_delay = 1000000/format.getSampleRate();
    System.out.println("CPC tape delay is set to:" + CPC.tape_delay);

if (format.getChannels() >=2)
    CPC.tape_stereo = true;
else
    CPC.tape_stereo = false;
      // get the audio samples
      getSamples(stream);
    } catch (UnsupportedAudioFileException ex) {
      ex.printStackTrace();
    } catch (IOException ex) {
      ex.printStackTrace();
    }
  }


  /**
   * Gets the samples from an AudioInputStream as an array of bytes.
   */
  private void getSamples(AudioInputStream audioStream) {
    // get the number of bytes to read
    int length = (int) (audioStream.getFrameLength() * format.getFrameSize());
    // read the entire stream
    CPC.tapesample = new byte[length];
    DataInputStream is = new DataInputStream(audioStream);
    try {
      is.readFully(CPC.tapesample);
    } catch (IOException ex) {
      ex.printStackTrace();
    }
    try {
        is.close();
    }  catch (Exception ex) {
      ex.printStackTrace();
    }
  }
}


